!
!   EMT STRESS CALCULATION
!
      subroutine emtstress(nmax,nbook,n,rx,ry,rz,idpt,knum &
          ,hmat,rc,rc2,stressx,stressy,stressz,ef,iban)
      implicit double precision (a-h,o-z)
      double precision :: emte0, emte2, emte3 &
       ,emtn0, emteta, emts0, emtgam1, emtbet, emteta2 &
       ,emtrc, emta, emtalp, emtgam2
      double precision :: rx(nmax,5),ry(nmax,5),rz(nmax,5)
      double precision :: hmat(3,3,5)
      double precision :: emtsig1(nmax),emtsig2(nmax)
      integer :: idpt(nbook),knum(nmax)
      double precision :: ki

!   EMT PARAMETER
      emte0=-3.28d0*1.6022d-19
      emte2=1.12d0*1.6022d-19
      emte3=-0.35d0*1.6022d-19
      emtn0=0.007d0/((0.52d-10)**3)
      emteta=2.0d0/0.52d-10
      emts0=3.0d0*0.52d-10
      emtgam1=1.043d0
      emtbet=1.809d0
      emteta2=1.27d0/0.52d-10
      emtrc=11.50d0*0.52d-10
!      emta=-10.0d10
      emta=-10.0d0
      emtalp=288.36d-49
      emtgam2=1.069d0
!   EMT PARAMETER END

      stressx=0.0d0
      stressy=0.0d0
      stressz=0.0d0
      ef=0.0d0
      emtsig1=0.0d0
      emtsig2=0.0d0

!   First Loop: Chg dns calc
      kns=0
      do 4200 k=1,n-1
         kn=knum(k)
         if (kn.eq.0) go to 4200
         do 4300 jk=1,kn
            kns=kns+1
            j=idpt(kns)
            rxo=rx(k,iban)-rx(j,iban)
            ryo=ry(k,iban)-ry(j,iban)
            rzo=rz(k,iban)-rz(j,iban)
            dxx1=0.0d0
            dyy1=0.0d0
            xx=rxo
            yy=ryo
            zz=rzo
            
            a1=hmat(1,1,iban)
            a2=hmat(2,1,iban)
            a3=hmat(3,1,iban)
            a4=hmat(1,2,iban)
            a5=hmat(2,2,iban)
            a6=hmat(3,2,iban)
            a7=hmat(1,3,iban)
            a8=hmat(2,3,iban)
            a9=hmat(3,3,iban)

            if (abs(xx).ge.rc) then
             if (xx.gt.0.0) then
                xx=xx-a1
                yy=yy-a2
                zz=zz-a3
             else if (xx.lt.0.0) then
                xx=xx+a1
                yy=yy+a2
                zz=zz+a3
             endif
            endif
            if (abs(yy).ge.rc) then
             if (yy.gt.0.0) then
                xx=xx-a4
                yy=yy-a5
                zz=zz-a6
             else if (yy.lt.0.0) then
                xx=xx+a4
                yy=yy+a5
                zz=zz+a6
             endif
            endif
            if (abs(zz).ge.rc) then
             if (zz.gt.0.0) then
                xx=xx-a7
                yy=yy-a8
                zz=zz-a9
             else if (zz.lt.0.0) then
                xx=xx+a7
                yy=yy+a8
                zz=zz+a9
             endif
            endif
            r2=xx**2+yy**2+zz**2
            if (r2.lt.rc2) then
               r=sqrt(r2)
               emtthe=1.0d0/(1.0d0+exp(emta*(emtrc-r)))
               dxx1=exp(-emteta2*r)*emtthe
               dyy1=exp(-emteta/emtbet*r)*emtthe
            endif
            emtsig1(k)=emtsig1(k)+dxx1
            emtsig2(k)=emtsig2(k)+dyy1
            emtsig1(j)=emtsig1(j)+dxx1
            emtsig2(j)=emtsig2(j)+dyy1
 4300    continue
 4200 continue
      
!   Second Loop
      kns=0
      do 4500 k=1,n-1
         kn=knum(k)
         if (kn.eq.0) go to 4500
         emtnbi=emtn0*exp(emteta*emts0)*(emtsig1(k)/12.0d0/emtgam1) &
          **(emteta/emtbet/emteta2)
         emtnfi=emtn0*exp(emteta*emts0)*(emtsig2(k)/12.0d0/emtgam2)
         dednbi=2.0d0*emte2/emtn0*(emtnbi/emtn0-1.0d0) &
          +3.0d0*emte3/emtn0*(emtnbi/emtn0-1.0d0)**2+emtalp
         dnbds1i=emteta*emtnbi/emtbet/emteta2/emtsig1(k)
         dednfi=-emtalp
         dnfds2i=emtnfi/emtsig2(k)
         do 4600 jk=1,kn
            kns=kns+1
            j=idpt(kns)
            rxo=rx(k,iban)-rx(j,iban)
            ryo=ry(k,iban)-ry(j,iban)
            rzo=rz(k,iban)-rz(j,iban)
            dd1=0.0d0
            dxx1=0.0d0
            dyy1=0.0d0
            dzz1=0.0d0
            ki=0.0d0
            ff=0.0d0
            xx=rxo
            yy=ryo
            zz=rzo
            a1=hmat(1,1,iban)
            a2=hmat(2,1,iban)
            a3=hmat(3,1,iban)
            a4=hmat(1,2,iban)
            a5=hmat(2,2,iban)
            a6=hmat(3,2,iban)
            a7=hmat(1,3,iban)
            a8=hmat(2,3,iban)
            a9=hmat(3,3,iban)
            
            if (abs(xx).ge.rc) then
             if (xx.gt.0.0) then
                xx=xx-a1
                yy=yy-a2
                zz=zz-a3
             else if (xx.lt.0.0) then
                xx=xx+a1
                yy=yy+a2
                zz=zz+a3
             endif
            endif
            if (abs(yy).ge.rc) then
             if (yy.gt.0.0) then
                xx=xx-a4
                yy=yy-a5
                zz=zz-a6
             else if (yy.lt.0.0) then
                xx=xx+a4
                yy=yy+a5
                zz=zz+a6
             endif
            endif
            if (abs(zz).ge.rc) then
             if (zz.gt.0.0) then
                xx=xx-a7
                yy=yy-a8
                zz=zz-a9
             else if (zz.lt.0.0) then
                xx=xx+a7
                yy=yy+a8
                zz=zz+a9
             endif
            endif
            r2=xx**2+yy**2+zz**2
            if (r2.lt.rc2) then
               r=sqrt(r2)
               dtdr=emta*exp(emta*(emtrc-r)) &
                /((1.0d0+exp(emta*(emtrc-r)))**2)
               emtthe=1.0d0/(1.0d0+exp(emta*(emtrc-r)))
               ds1dri=exp(-emteta2*r)*(dtdr-emteta2*emtthe)
               dd1=dednbi*dnbds1i*ds1dri
               ds2dri=exp(-emteta/emtbet*r) &
                *(dtdr-emteta/emtbet*emtthe)
               dd1=dd1+dednfi*dnfds2i*ds2dri
               emtnbj=emtn0*exp(emteta*emts0) &
                   *(emtsig1(j)/12.0d0/emtgam1) &
                   **(emteta/emtbet/emteta2)
               dednbj=2.0d0*emte2/emtn0*(emtnbj/emtn0-1.0d0) &
                   +3.0d0*emte3/emtn0*(emtnbj/emtn0-1.0d0)**2+emtalp
               dnbds1j=emteta*emtnbj/emtbet/emteta2/emtsig1(j)
               ds1jdr=exp(-emteta2*r)*(dtdr-emteta2*emtthe)
               dd1=dd1+dednbj*dnbds1j*ds1jdr
               dednfj=-emtalp
               emtnfj=emtn0*exp(emteta*emts0) &
                   *(emtsig2(j)/12.0d0/emtgam2)
               dnfds2j=emtnfj/emtsig2(j)
               ds2jdr=exp(-emteta/emtbet*r) &
                   *(dtdr-emteta/emtbet*emtthe)
               dd1=dd1+dednfj*dnfds2j*ds2jdr
!---  jؤ---
               f=-dd1

               dxx1=f/r*xx
               dyy1=f/r*yy
               dzz1=f/r*zz
               rxo=xx
               ryo=yy
               rzo=zz
               ff=f/r*r2
               ki=f/r
            endif
            stressx=stressx-rxo*dxx1
            stressy=stressy-ryo*dyy1
            stressz=stressz-rzo*dzz1
            ef=ef+ff
 4600    continue
 4500 continue

      end

