!-----------------------------------------------------------------------
!      subroutine inverse (h,hi,deth,volume)
      subroutine inverse (h,hi)
!-----------------------------------------------------------------------
      implicit double precision (a-h,o-z),integer (i-n)
      double precision :: h(3,3),hi(3,3)
      double precision :: deth
      
!     Determinant of matrix h
      deth= h(1,1)*h(2,2)*h(3,3) + h(1,2)*h(2,3)*h(3,1) &
      +     h(1,3)*h(2,1)*h(3,2) - h(1,1)*h(2,3)*h(3,2) &
      -     h(1,2)*h(2,1)*h(3,3) - h(1,3)*h(2,2)*h(3,1)
      
!     Inverse matrix hi
      hi(1,1)=(h(2,2)*h(3,3)-h(2,3)*h(3,2))/deth
      hi(1,2)=(h(1,3)*h(3,2)-h(1,2)*h(3,3))/deth
      hi(1,3)=(h(1,2)*h(2,3)-h(1,3)*h(2,2))/deth
      hi(2,1)=(h(2,3)*h(3,1)-h(2,1)*h(3,3))/deth
      hi(2,2)=(h(1,1)*h(3,3)-h(1,3)*h(3,1))/deth
      hi(2,3)=(h(1,3)*h(2,1)-h(1,1)*h(2,3))/deth
      hi(3,1)=(h(2,1)*h(3,2)-h(2,2)*h(3,1))/deth
      hi(3,2)=(h(1,2)*h(3,1)-h(1,1)*h(3,2))/deth
      hi(3,3)=(h(1,1)*h(2,2)-h(1,2)*h(2,1))/deth

!     Volume of unit cell (m**3)
!      volume=dabs(deth)
      
!      return
      end

!      subroutine inverse(a,b)
!      implicit double precision (a-h,o-z)
!      double precision a(3,3),b(3,3)
!      do i=1,3
!         do j=1,3
!            b(i,j)=a(i,j)
!         enddo
!      enddo
!      do 100 k=1,3
!         p=b(k,k)
!         b(k,k)=1.0d0
!         do 1 j=1,3
!            b(k,j)=b(k,j)/p
! 1       continue
!         do 2 i=1,3
!            if (i.ne.k) then
!               q=b(i,k)
!               b(i,k)=0.0d0
!               do 3 j=1,3
!                  b(i,j)=b(i,j)-q*b(k,j)
! 3             continue
!            endif
! 2       continue
! 100  continue
!      return
!      end
