!
!   Modified EAM potential
!   for Sn (tin)
!    
!   calculation of force, total energy, stress
!

      subroutine meam_RaveloSn_ref
      use meam_RaveloSn_function
      use variables
      use constants
      use bookkeep_param
      use debug_variables
      use bookkeep_param
      use debug_variables
      implicit double precision (a-h,o-z)
!      implicit none
!      double precision :: strmat_store(3,3),hmat_store(3,3)
!      double precision,allocatable :: rx_store(:),ry_store(:),rz_store(:)
!      double precision :: inf_str
      double precision :: ki

      double precision :: strmat_store(3,3),hmat_store(3,3)
      double precision,allocatable :: rx_store(:),ry_store(:),rz_store(:)
      double precision :: inf_str

      strmat_store=strmat_set   ! Strain matrix save
                                ! (should be restored before return)

      allocate (rx_store(n),ry_store(n),rz_store(n))
      hmat_store=hmat           ! Cell matrix save
      rx_store=rx; ry_store=ry; rz_store=rz ! Atom position save

      if (bookkeep_algo /= 2) then
         stop 'Error in tersoff.F: Bookkeep algo is not DOUBLE'
      endif

      if (.not.(allocated(rhob))) then
         allocate (rhob(n),rhobp(n,0:3),gamma(n))
         allocate (rs(n),xrs(n,3),xxrs(n,3,3),xxxrs(n,3,3,3))
         allocate (ss(n,n))
         allocate (ds_x(n,n),ds_y(n,n),ds_z(n,n))
         allocate (ds_e(n,n,3,3),drhob_e(n,3,3))
         allocate (drhob_x(n,n),drhob_y(n,n),drhob_z(n,n))
      endif
      
!--
      pi=4.0d0*atan(1.0d0)
      eps=1.0d-30; eps0=1.0d-10
      ev2j=1.6021892d-19        !eV -> J
      j2ev=1.0d0/ev2j           !J -> eV
!  PARAMETER
!  For Sn
      aa(1)=   1.0d0
      rho0(1)= 1.0d0
      rr0(1)=  3.44d-10
      ee0(1)=  3.08d0*ev2j
      alp(1)=  6.20d0
      bet0(1)= 6.2d0
      bet1(1)= 6.0d0
      bet2(1)= 6.0d0
      bet3(1)= 6.0d0
      t00(1)=  1.0d0
      t01(1)=  4.5d0
      t02(1)=  6.505d0
      t03(1)= -0.183d0
      ccmin(1)=0.8d0
      ccmax(1)=2.8d0

!      t00(1)=0.0
!      t01(1)=0.0
!      t02(1)=0.0
!      t03(1)=0.0

! Geometry factors
!      ss0=1.0d0
!      ss1=0.0d0
!      ss2=0.0d0
!      ss3=32.0d0/9.0d0
      zz0=12.0d0

!--
      istat=1

!      rc=4.5d-10
      rc=3.9d-10
      rc2=rc**2


      inf_str=0.004
!      rmin=1.5d-10
!      rmax=4.5d-10
      rmin=1.0d-10
      rmax=6.0d-10

      open (50,FILE='pot/meam_sn_ref.d')
!      open (50,FILE='pot/meam_sn_ref_SNN.d')

      if (n==4*3**3) then
         nnn=3
         xx=hmat(1,1)/3.0/sqrt(2.0)
      else if (n==4*4**3) then
         nnn=4
         xx=hmat(1,1)/4.0/sqrt(2.0)
      else
         print *,'Error in meam_RaveloSn_ref: N must be 108 or 256.'
         stop
      end if

      imin=int((rmin-xx)/xx/inf_str)
      imax=int((rmax-xx)/xx/inf_str)
      print *,xx,imin,imax
      do iii=imin,imax

      hmat=hmat_store
      rx=rx_store; ry=ry_store; rz=rz_store

      strmat_set=0.0d0
      strmat_set(1,1)=inf_str*iii
      strmat_set(2,2)=inf_str*iii
      strmat_set(3,3)=inf_str*iii
      call strain
     
      rnnn=hmat(1,1)/dble(nnn)/sqrt(2.0)
!      rnnn=hmat(1,1)/dble(nnn)       !<<== up to 2nd neighbor
      rc=rnnn*1.2
      rc2=rc**2

      if (hmat(1,1)<rc*3) stop 'hmat(1,1) too small'
      if (hmat(2,2)<rc*3) stop 'hmat(2,2) too small'
      if (hmat(3,3)<rc*3) stop 'hmat(3,3) too small'


!   Virial term reset
      virx=0.0d0; viry=0.0d0; virz=0.0d0
      dmat=0.0d0
      satom=0.0d0               ! Atomic stress

!   Loop
      enpot=0.0d0
      enpoteach=0.0d0
      fx(1:n)=0.0d0
      fy(1:n)=0.0d0
      fz(1:n)=0.0d0

      rhob=0.0d0; rhobp=0.0d0
      ss=0.0d0; ds_x=0.0d0;ds_y=0.0d0;ds_z=0.0d0
      drhob_x=0.0d0;drhob_y=0.0d0;drhob_z=0.0d0
      ds_e=0.0d0

! 1st set of loops
      xx=0.0d0; xxx=0.0d0
      kns=0
      iloop1: do i=1,n
         rix=rx(i)
         riy=ry(i)
         riz=rz(i)
         kn=knum(i)
         if (kn.eq.0) cycle
         kns0=kns
         tmpa=0.0d0;tmpb=0.0d0;tmpc=0.0d0;tmpbb=0.0d0
         jloop1: do jcount=1,kn
            kns=kns+1
            j=idpt(kns,1)
            ix=idpt(kns,2); iy=idpt(kns,3); iz=idpt(kns,4)
            xx=rx(i)-rx(j); yy=ry(i)-ry(j); zz=rz(i)-rz(j)
            call calc_replica(xx,yy,zz,rc,ix,iy,iz,istat)
            rjx=rx(i)-xx; rjy=ry(i)-yy; rjz=rz(i)-zz
            rij2=(rjx-rix)**2+(rjy-riy)**2+(rjz-riz)**2
            if (rij2.le.eps) go to 201
            if (rij2.ge.rc2) go to 201
            rij=sqrt(rij2)
            rji=rij; rji2=rij2
            
            sji=1.0d0;

            knsk=kns0
            kloop1: do kcount=1,kn   ! <to calculate S_ij>
               knsk=knsk+1
               k=idpt(knsk,1)
               ix=idpt(knsk,2); iy=idpt(knsk,3); iz=idpt(knsk,4)
               xx=rx(i)-rx(k); yy=ry(i)-ry(k); zz=rz(i)-rz(k)
               call calc_replica(xx,yy,zz,rc,ix,iy,iz,istat)
               rkx=rx(i)-xx; rky=ry(i)-yy; rkz=rz(i)-zz
               rik2=(rkx-rix)**2+(rky-riy)**2+(rkz-riz)**2
               
               if (rik2.le.eps) go to 301
!               if (rik2.ge.rc2) go to 301
               rik=sqrt(rik2)
               rki=rik; rki2=rik2
               rjk2=(rkx-rjx)**2+(rky-rjy)**2+(rkz-rjz)**2
               if (rjk2.le.eps) go to 301
               rjk=sqrt(rjk2)
               rkj=rjk; rkj2=rjk2
               
               xxik=(rik2/rij2); xxjk=(rjk2/rij2)
               cos1=(rik2+rij2-rjk2)/(2.0*rik*rij)
               cos2=(rij2+rjk2-rik2)/(2.0*rij*rjk)
               if ((abs(xxik-xxjk)-1.0<eps0).and.(abs(xxik-xxjk)-1.0>-eps0)) then
                  cc=-1.0d0
               else if ((cos1<=0.0).or.(cos2<=0.0)) then
                  cc=-1.0d0
               else
                  cc=( 2.0d0*(xxik+xxjk) - (xxik-xxjk)**2 - 1.0d0 ) / ( 1.0d0-(xxik-xxjk)**2 )
               endif
               if ((tsp(asp(i))==1).and.(tsp(asp(j))==1)) then
                  cmin=ccmin(1); cmax=ccmax(1)
!               else if ((tsp(asp(i))==2).and.(tsp(asp(j))==2)) then
!                  cmin=ccmin(2); cmax=ccmax(2)
!               else
!                  cmin=ccmin(3); cmax=ccmax(3)
               endif
               if (cc<=0.0) then
                  sjki=1.0d0
               else if (cc<=cmin) then
                  sjki=0.0d0
               else if (cc<=cmax) then
                  sjki=(1.0d0-((cmax-cc)/(cmax-cmin))**4)**2
               else
                  sjki=1.0d0
               endif
               sji=sji*sjki
               if ((i==1).and.(j==2).and.(sjki==0.0)) print *,k,rij,rik,rjk,cc,xxik,xxjk

301            continue
            end do kloop1
            sij=sji; ss(j,i)=sji; ss(i,j)=sij

            ispc=tsp(asp(i)); jspc=tsp(asp(j))

! bar{rho}_i^(k)
            rhobp(i,0)=rhobp(i,0)+rhoa(j,i,0,rji)*sji
            xij(1)=(rjx-rix)/rij; xij(2)=(rjy-riy)/rij; xij(3)=(rjz-riz)/rij
            do ia=1,3
               tmpa(ia)=tmpa(ia)+xij(ia)*rhoa(j,i,1,rji)*sji
               do ip=1,3
                  tmpb(ia,ip)=tmpb(ia,ip)+xij(ia)*xij(ip)*rhoa(j,i,2,rji)*sji
                  do iq=1,3
                     tmpc(ia,ip,iq)=tmpc(ia,ip,iq)+xij(ia)*xij(ip)*xij(iq)*rhoa(j,i,3,rji)*sji
                  enddo
               enddo
            enddo
            tmpbb=tmpbb+rhoa(j,i,2,rji)*sji
201         continue
         end do jloop1

         rs(i)=tmpbb
         do ia=1,3
            xrs(i,ia)=tmpa(ia)
            do ip=1,3
               xxrs(i,ia,ip)=tmpb(ia,ip)
               do iq=1,3
                  xxxrs(i,ia,ip,iq)=tmpc(ia,ip,iq)
               enddo
            enddo
         enddo
         
         do ia=1,3
            rhobp(i,1)=rhobp(i,1)+tmpa(ia)**2
            do ip=1,3
               rhobp(i,2)=rhobp(i,2)+tmpb(ia,ip)**2
               do iq=1,3
                  rhobp(i,3)=rhobp(i,3)+tmpc(ia,ip,iq)**2
               enddo
            enddo
         enddo
         rhobp(i,1)=sqrt(rhobp(i,1))
         if (rhobp(i,2)-rs(i)**2/3.0d0>0.0) then
            rhobp(i,2)=sqrt(rhobp(i,2)-rs(i)**2/3.0d0)
         else
            rhobp(i,2)=0.0d0
         endif
         rhobp(i,3)=sqrt(rhobp(i,3))

         gamma(i)=(t01(ispc)*rhobp(i,1)**2+t02(ispc)*rhobp(i,2)**2+t03(ispc)*rhobp(i,3)**2)/rhobp(i,0)**2
         rhob(i)=2.0d0/rho0(ispc)/zz0*rhobp(i,0)/(1.0d0+exp(-gamma(i)))
!         rhob(i)=2.0d0/rho0(ispc)*rhobp(i,0)/(1.0d0+exp(-gamma(i)))

      end do iloop1

      print *,rnnn/ang,rhob(1)
      write (50,*) rnnn/ang,rhob(1)
      
      end do
      close (50)
      
    end subroutine meam_RaveloSn_ref
